/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qcstring.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qprocess.h>
#include <qregexp.h>
#include <qfile.h>
#include <qdir.h>
#include <qmessagebox.h>
#include <vector>
#include "./.ui/wait.h"

using std::vector;

typedef struct
{
	QString name;
	vector<QString*> packages;
}category;

QString RESDIR("./"),CAT("/cats/"),DES("/desc/"),COM("/res/"),DEF("_default"),LOCALE("en"),DATA("/data/");
vector<category*> vcats;

QPixmap *screen;
QProcess* install,*run;
QMessageBox* runFail = 0;
QMessageBox* installFail = 0,*installSucceed=0;
QDir localDescD,globDescD,resD,defResD,DIR;
QTextCodec * decoder;
QMap<QString,QString> catDict;

QMap<QString,QString> f2nDict;
QMap<QString,QString> n2fDict;

QMap<QString,bool> noinstall;
QMap<QString,bool> norun;

QString appDir(RESDIR);

wndWait* waitWindow;

void window::init()
{
	LOCALE=QTextCodec::locale();
	LOCALE=LOCALE.left(2);
	decoder=QTextCodec::codecForName("utf8");
	RESDIR=appDir;
	findExtras();

	DIR.setPath(RESDIR);
	localDescD.setPath(RESDIR+DATA+DES+LOCALE);
	globDescD.setPath(RESDIR+DATA+DES+QString("en"));
	resD.setPath(RESDIR+DATA+COM);
	defResD.setPath(resD.absPath()+"/"+DEF);
	setenv("DIR",RESDIR,1);
	
	if(LOCALE!="en")
	{
		QFile catn(RESDIR+DATA+CAT+"names_"+LOCALE);
		qDebug(catn.name().ascii());
		if(catn.open(IO_ReadOnly))
		{
			QString line;
			while(catn.readLine(line,1024)>0)
			{
				line=decoder->toUnicode(line);
				int breakId=line.find('=');
				if(breakId<=0)continue;
  				catDict[line.left(breakId-1).stripWhiteSpace()]=line.mid(breakId+1,line.length()-breakId).stripWhiteSpace();
			}
			catn.close();
		}
	}
	
	QFile pakn(RESDIR+DATA+CAT+"packages_"+LOCALE);
	qDebug(pakn.name().ascii());
	if(pakn.open(IO_ReadOnly))
	{
		QString line;
		while(pakn.readLine(line,1024)>0)
		{
			line=decoder->toUnicode(line);
			int breakId=line.find('=');
			if(breakId<=0)continue;
  			f2nDict[decoder->toUnicode(line.left(breakId-1).stripWhiteSpace())]=line.mid(breakId+1,line.length()-breakId).stripWhiteSpace();
			n2fDict[line.mid(breakId+1,line.length()-breakId).stripWhiteSpace()] = line.left(breakId-1).stripWhiteSpace();
		    }
		pakn.close();
	}

	QFile fcats(RESDIR+DATA+CAT+"list");
	qDebug(fcats.name().ascii());
	QRegExp token("^\\[[a-zA-Z0-9]+\\]");
	QString line;

	install=new QProcess(this,"Installation Process");
	run=new QProcess(this,"Run Process");
	screen=new QPixmap;
	
	runFail=new QMessageBox(QObject::tr("Error"),QObject::tr("Run failed."),QMessageBox::Warning,QMessageBox::Ok,QMessageBox::NoButton, QMessageBox::NoButton, this);
	installFail=new QMessageBox(QObject::tr("Error"),QObject::tr("Installation failed."),QMessageBox::Warning,QMessageBox::Ok,QMessageBox::NoButton, QMessageBox::NoButton, this);
	//runSucceed=new QMessageBox(QObject::tr("Success"),QObject::tr("Run succeed."),QMessageBox::Information,QMessageBox::Ok,QMessageBox::NoButton, QMessageBox::NoButton, this);
	installSucceed=new QMessageBox(QObject::tr("Success"),QObject::tr("Installation succeed."),QMessageBox::Information,QMessageBox::Ok,QMessageBox::NoButton, QMessageBox::NoButton, this);

	category * currentCat=0;
	fcats.open(IO_ReadOnly);
	while(fcats.readLine(line,1024)>0)
	{
		line=decoder->toUnicode(line);
		line=line.stripWhiteSpace();
		if(! line.length())continue;
		if(token.exactMatch(line))
		{
		    currentCat=new category;
		    line=line.mid(1,line.length()-2);
		    currentCat->name=catDict.find(line)!=catDict.end()?catDict[line]:line;
		    cats->insertItem(currentCat->name);
		    vcats.push_back(currentCat);
		}
		else
		{
		    QString iLine=line;
		    iLine=iLine.remove( QRegExp("%![RI]",false )).stripWhiteSpace();
		    if(line.find(QRegExp("%!I",false))>=0){noinstall[iLine]=true;}
		    if(line.find(QRegExp("%!R",false))>=0){norun[iLine]=true;}
		    currentCat->packages.push_back(new QString(file2name(iLine)));
		}
	}
	fcats.close();
	listPackages( 0);
	connect(install,SIGNAL(processExited()),this,SLOT(installCheckSlot()));
	connect(run,SIGNAL(processExited()),this,SLOT(runCheckSlot()));
	waitWindow=new wndWait;
}

void window::listPackages( int n )
{
	qDebug("listPackages %d",n);
	progs->clear();
	vector<QString*> pc;
	unsigned pn;
	if(!n)
	{
		unsigned NUM=vcats.size();
		for(unsigned j=0;j<NUM;++j)
		{
		pc=(vcats[j]->packages);
		pn=pc.size();
		for(unsigned i=0;i<pn;++i)
		{
			progs->insertItem(*(pc[i]));
		}
		}
	}
	else
	{
		pc=(vcats[n-1]->packages);
		pn=pc.size();
		for(unsigned i=0;i<pn;++i)
		{
		progs->insertItem(*(pc[i]));
		}
	}
	progs->sort();
}

void window::setPackage(const QString & NI)
{
	static const QString shell("/bin/bash"),installsh("install.sh"), runsh("run.sh"), Sinstallsh("/install.sh"),Srunsh("/run.sh"),screenpng("screen.png"),Sscreenpng("/screen.png");
	QString n=name2file(NI);
	QDir appD;
	QFile desc;
	qDebug("Pakiet %s",n.ascii());
	
	btnInstall->setEnabled(!noinstall.contains(n));
	btnRun->setEnabled(!norun.contains(n));
	
	if(localDescD.exists(n))
		desc.setName(localDescD.absPath()+"/"+n);
	else if(globDescD.exists(n))
		desc.setName(globDescD.absPath()+"/"+n);
	else if(localDescD.exists(DEF))
		desc.setName(localDescD.absPath()+"/"+DEF);
	else if(globDescD.exists(DEF))
		desc.setName(globDescD.absPath()+"/"+DEF);
	
	qDebug("Opis pochodzi z %s",desc.name().ascii());
	
	if(resD.exists(n))appD.setPath(resD.absPath()+"/"+n);
	else appD=defResD;

	if(appD.exists(screenpng))	screen->load(appD.absPath()+Sscreenpng);
	else	screen->load(defResD.absPath()+Sscreenpng);
	
	desc.open(IO_ReadOnly);
	QString line;
	QString text;
		while(desc.readLine(line,1024)>=0)text+=decoder->toUnicode(line);
	description->setText(text);
	
	screenshot->setPixmap(*screen);
	
	install->clearArguments();
	run->clearArguments();
	install->addArgument(shell);
	run->addArgument(shell);
	
	if(appD.exists(installsh))
		install->addArgument(appD.absPath()+Sinstallsh);
	else //(defResD.exists(installsh))
		install->addArgument(defResD.absPath()+Sinstallsh);
	
	if(appD.exists(runsh))
		run->addArgument(appD.absPath()+Srunsh);
	else //(defResD.exists(runsh))
		run->addArgument(defResD.absPath()+Srunsh);
	
	install->addArgument(n);
	run->addArgument(n);
}

void window::runSlot()
{
	qDebug("Running");
	if(! run->launch(QString()))runFail->exec();
	else
	{
	    waitWindow->pleaseWait(tr("Running"));
	}
}

void window::installSlot()
{
	qDebug("Install");
	if(!install->launch(QString()))installFail->exec();
	else
	{
	    waitWindow->pleaseWait(tr("Installation"));
	}
}

void window::installCheckSlot()
{	
    waitWindow->hide();
	if(install->normalExit())
	{
	    if(install->exitStatus()==0){installSucceed->exec();
		return;}
	}
	installFail->exec();
}

void window::runCheckSlot()
{
    waitWindow->hide();
        if(run->normalExit())
    {
	if(run->exitStatus()==0)
	    {
	  //  runSucceed->exec();
	    return;}
    }
    runFail->exec();
}

void window::findExtras()
{
    char bufor[512];
    
   FILE * pipe=popen("cat /proc/mounts | grep -E '^/dev/' | cut -d ' ' -f2| sort -r","r");
    while(fgets(bufor,512,pipe))
    {
		if(char * c=strrchr(bufor,'\n'))*c='\0';
		QDir searchd(QString(bufor)+QString("/extras/"));
		qDebug(searchd.absPath().ascii());
	    	if(searchd.exists())
		{
			
			QDir sd(searchd.absPath()+DATA+CAT);
			if(!sd.exists("list"))continue;
			RESDIR=searchd.absPath();
			qDebug(RESDIR);
			DIR.setPath(RESDIR);
			pclose(pipe);
			return;
		}
	}
	qDebug("Nie znaleziono");
	pclose(pipe);
}

QString window::name2file( QString a )
{
    QMap<QString,QString>::const_iterator i=n2fDict.find(a);
    if(i!=n2fDict.end())return *i;
    else return a;
}

QString window::file2name( QString a)
{
    QMap<QString,QString>::const_iterator i=f2nDict.find(a);
    if(i!=f2nDict.end())return *i;
    else return a;
}	

void window::searchCH(const  QString &input )
{
    progs->setSelected(progs->findItem(input),TRUE);
}

void window::setAppDir( QString ad )
{
    appDir=ad;
}
